package com.test.security;

import java.security.acl.Group;
import java.util.Map;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginException;

import org.jboss.security.SimpleGroup;
import org.jboss.security.auth.spi.UsernamePasswordLoginModule;

public class TestLoginModule extends UsernamePasswordLoginModule {

    public TestLoginModule() {
        super();
        System.out.println("Created TestLoginModule login module");
    }

    @Override
    public void initialize(Subject subject, CallbackHandler callbackHandler, Map sharedState, Map options) {
        super.initialize(subject, callbackHandler, sharedState, options);
    }

    @Override
    protected String getUsersPassword() throws LoginException {
        return "123"; // any value.. will not be used. validatePassword(..) always return true
    }
    
    @Override
    protected boolean validatePassword(String inputPassword, String expectedPassword) {
        return true;
    }
    
    
    @Override
    protected Group[] getRoleSets() throws LoginException {
        
        System.out.println("Get rolesets for " + super.getUsername());
        
        Group secureUser = new SimpleGroup("Roles");
        try {
            secureUser.addMember(this.createIdentity("SecureUser"));
        } catch (Exception e) {
            log.error("Failed to create principal: SecureUser", e);
        }
        Group[] roleSets = new Group[] { secureUser };
        
        return roleSets;
    }
}
