package com.test.security;

import java.security.Principal;
import java.security.acl.Group;
import java.util.Map;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginException;

import org.jboss.security.SimpleGroup;
import org.jboss.security.SimplePrincipal;
import org.jboss.security.auth.spi.UsernamePasswordLoginModule;

public class TestLoginModule2 extends UsernamePasswordLoginModule {

    public TestLoginModule2() {
        super();
        System.out.println("Created TestLoginModule2 login module");
    }

    @Override
    public void initialize(Subject subject, CallbackHandler callbackHandler, Map sharedState, Map options) {
        super.initialize(subject, callbackHandler, sharedState, options);
    }

    @Override
    protected String getUsersPassword() throws LoginException {
        return "123"; // any value.. will not be used. validatePassword(..) always return true
    }
    
    @Override
    protected boolean validatePassword(String inputPassword, String expectedPassword) {
        return true;
    }

    @Override
    protected Group[] getRoleSets() throws LoginException {
        Group[] roleSets = {new SimpleGroup("Roles"), new SimpleGroup("CallerPrincipal")};        
        Principal identity = getIdentity();
        roleSets[0].addMember(new SimplePrincipal("user"));
        roleSets[0].addMember(new SimplePrincipal(identity.getName()));
        roleSets[1].addMember(identity);
        return roleSets;
    }
}
